'EdW prostownik automatyczny na miar
'data: 10.12.2012
'program: Bascom AVR 1.11.9.5
'autor: Piotr wierczek


$regfile = "m8def.dat"

$crystal = 8000000

$hwstack = 32
$swstack = 40
$framesize = 40

'konfiguracja przetwornika  A/D

Config Adc = Single , Prescaler = Auto , Reference = Internal
Start Adc

' zmienne

Dim Wart_u As Word
Dim Wart_i As Word
Dim V As Single , I As Single , Vv As Single
Dim Wart_pr As String * 3
Dim Wart_nap As String * 3
Dim A As Single

Dim Pulses As Word , Periods As Word                        'dane dla dwiku alarmowego
Pulses = 2000 : Periods = 200

'definicja kilku polskich znakw

Deflcdchar 0 , 31 , 16 , 16 , 30 , 16 , 20 , 31 , 2
Deflcdchar 1 , 14 , 17 , 17 , 31 , 17 , 17 , 17 , 2
Deflcdchar 2 , 16 , 16 , 20 , 24 , 16 , 16 , 31 , 32
Deflcdchar 3 , 14 , 17 , 17 , 31 , 17 , 17 , 19 , 4


'konfiguracja LCD


Config Lcd = 16 * 2

Config Lcdpin = Pin , Db4 = Portc.1 , Db5 = Portc.0 , Db6 = Portb.2 , Db7 = Portb.1 , E = Portc.2 , Rs = Portc.3


Config Portd.0 = Output                                     'konfiguracja wyj i stanu
Config Portd.1 = Output
Ster Alias Portd.0
Beep Alias Portd.1
Ster = 0
Beep = 0

Cls

Cursor Off
Lcd "   PROSTOWNIK"                                         'tekst powitalny
Lowerline
Lcd "  AUTOMATYCZNY"
Wait 2
Cls
Lcd "     POD" ; Chr(2) ; Chr(3) ; "CZ"                     'Chr(2) to  a Chr(3) to  ustawione wyej
Lowerline
Lcd "   AKUMULATOR"
Wait 8                                                      '8 sekund na podaczenie akumulatora

 Cls


 For A = 1 To 15
                                                            'pomiar napicia na akumulatorze
 Wart_u = Getadc(5)                                         'przed adowaniem
 Vv = Wart_u * 0.025
 Wart_nap = Fusing(vv , "##.&&")


 Lcd "NA AKUMULATORZE"

 Lowerline
 Lcd "NAPI" ; Chr(0) ; "CIE  " ; Wart_nap ; "V" ; Spc(1)        'pokazanie wartoci napicia

 Wait 1
 Next A


'program waciwy, ptla gwna

 Do



 Cls

 Ster = 1                                                   'zaczenie adowania

 For A = 1 To 25                                            'ptla pomocnicza 25s adowanie z pomiarem


 Wart_i = Getadc(4)                                         'pomiar prdu
 I = Wart_i * 0.05
 Wart_pr = Fusing(i , "##.&&")


 Lcd "PROSTOWNIK PRACA"
 Lowerline
 Lcd Chr(2) ; "ADOWANIE " ; Wart_pr ; "A" ; Spc(1)          'pokazanie wartoci prdu adowania na LCD


 Wait 1
 Next A


 Ster = 0                                                   'wyaczenie adowania
 Wait 2                                                     'na 2s dla ustalenia napicia

 Wart_u = Getadc(5)                                         'pomiar napicia
 Vv = Wart_u * 0.025
 Wart_nap = Fusing(vv , "##.&&")

 Cls

 Lcd "FAZA TESTOWANIA"                                      'pokazanie wartoci napicia
 Lowerline
 Lcd "NAPI" ; Chr(0) ; "CIE  " ; Wart_nap ; "V" ; Spc(1)
 Wait 5

 If Vv > 14.5 Then                                          'porwnanie wartoci napicia z zadanym
 Ster = 0
 Cls
 Lcd "****************"
 Lowerline
 Lcd "KONIEC " ; Chr(2) ; "ADOWANIA"
 For A = 1 To 5                                             'generowanie alarmu 5 impulsw
 Sound Beep , Pulses , Periods
 Waitms 500
 Next A

 Wait 1800                                                  'ponowne zaaczenie za 30 minut

 'Wait 360                                                   'zadany czas w sekundach do ponownego doadowania
 Cls                                                        'tutaj ustawione jest przykadowo 6minut dla testw
 Else
 End If
 Waitms 100


 Loop

 ' zostao jeszcze prawie 70% wolnego miejsca w pamici na wasne eksperymenty :-))